// ----[ Vertex Shader ]----
void VS( float3 vPosIn     : POSITION,
         float4 vDiffuseIn : COLOR,
         float4 uv1        : TEXCOORD0,  // .xy = warped UVs, .zw = orig UVs
         float2 uv2        : TEXCOORD1,  // .x = rad, .y = ang
     out float4 vPosProj   : POSITION,
     out float4 vDiffuse   : COLOR, 
     out float4 uv         : TEXCOORD0, 
     out float2 rad_ang    : TEXCOORD1 )
{  
    vPosProj = float4(vPosIn.x, vPosIn.y, vPosIn.z, 1);
    vDiffuse = vDiffuseIn;
    uv = uv1;
    rad_ang = uv2.xy;
}
